package schedframe.scheduling.manager.tasks;


import java.util.List;
import java.util.Map;

import dcworms.schedframe.scheduling.ExecTask;
import schedframe.ExecutablesList;
import schedframe.resources.units.ResourceUnit;
import schedframe.resources.units.ResourceUnitName;
import schedframe.scheduling.tasks.JobInterface;
import schedframe.scheduling.tasks.TaskInterface;


public interface JobRegistry {

	public JobInterface<?> getJobInfo(String jobId);
	
	public List<JobInterface<?>> getJobs();
	
	public List<JobInterface<?>> getJobs(int status);
	

	public TaskInterface<?> getTaskInfo(String jobId, String taskId);
	
	public ExecutablesList getTasks(); 
	
	public ExecTask getTask(String jobId, String taskId);

	
	public List<ExecTask> getTasks(int status);

	public List<ExecTask> getTasks(List<Integer> statusList, boolean match);

	public List<ExecTask> getQueuedTasks();
	
	public List<ExecTask> getRunningTasks();
	
	public List<ExecTask> getReadyTasks();
	
	public List<ExecTask> getFinishedTasks();

	
	public List<? extends TaskInterface<?>> getAvailableTasks(List<JobInterface<?>> jobsList);
	
	
	public boolean pauseTask(String jobId, String taskId);
	
	public boolean resumeTask(String jobId, String taskId);
	
	public boolean migrateTask(String jobId, String taskId, Map<ResourceUnitName, ResourceUnit> choosenResources);
	
	public boolean migrateTask(String jobId, String taskId, String nodeName);
	

}
